<?php

namespace %NAMESPACE%\Lib;

use Picea\Picea;
use Storage\Session;
use Ulmus\User\Entity\User;
use Ulmus\User\Lib\Authenticate;
use Notes\Route\Attribute\Object\Route;
use Notes\Security\Attribute\Security;
use %NAMESPACE%\Entity;

use Mcnd\Event\EventManager;

#[Security(locked: false)]
#[Route(method: ['GET', 'POST', ])]
trait ControllerTrait {
    use \Lean\ControllerTrait;

    public ? \Ulmus\User\Entity\User $user;

    protected Authenticate $authenticate;

    protected EventManager $eventManager;

    public function __construct(Picea $picea, Session $session, Authenticate $authenticate, \Notes\Breadcrumb\Breadcrumb $breadcrumb, EventManager $eventManager) {
        $this->initializeController($picea, $session, $authenticate, $breadcrumb, $eventManager);
    }

    public function initializeController(Picea $picea, Session $session, Authenticate $authenticate, \Notes\Breadcrumb\Breadcrumb $breadcrumb, EventManager $eventManager) {
        $this->picea = $picea;
        $this->authenticate = $authenticate;
        $this->session = $session;
        $this->eventManager = $eventManager;
        $this->breadcrumb = $breadcrumb;
        $this->user = $authenticate->rememberMe( Entity\User::repository() ) ?: new Entity\User();
    }

}